(* Letzte Bearbeitung : 03.09.1991 14:20 Datei : TESTSIO3.PAS                   *)

(* Version 1C *)

(* Kommunikation zweier COMxx - Schnittstellen :

   - die COMxx Schnittstellen mssen definiert werden mit MC4CONF.EXE:
     => Die Dateien CONFIGxx.ADD und MC4CONF.INS werden erzeugt
   - die Dateien CONFIGxx.ADD mssen bernommen werden in CONFIG.SYS
   - das Programm ML4LAB.EXE mu aufgerufen werden:

                  ML4LAB MC4CONF

     => Die Kommunikationsprogramme (.LAB Dateien) werden erzeugt

   - das System mu neu gestartet werden mit CTRL+ALT+DEL
   - die Schnittstellen mssen mit ML4MULT installiert und ggf.initialisiert
     werden:
                  ML4MULT MC4CONF

   - Start dieses Programms (s.a. Beschreibung MS-DOS Einheitentreiber *)

(* Test : Kommunikation ber den Software-Interrupt 21H : AH = 44H (IOCTL) *)

program test_sio;
uses
    Crt,Dos;
var
   regs : registers;
   speicher1,speicher2 : array[1..8000] of char;
   l,k,i : integer;
   name : string[20];
   kanal1,kanal2 : integer;
   fil : text; (* Input - Dateien *)

begin
  clrscr;
  writeln('Senden der Zeichen dieser Datei ber die Schnittstelle COM5 und');
  writeln('Empfangen der Zeichen von der Schnittstelle COM6 und');
  writeln('Ausgabe auf den Bildschirm');
  writeln;

(* ffnen der Text-Datei (Schnittstelle) COM5 *)

  name := 'COM6' + chr(0);
  with regs do
    begin
      ax := $3D02;
      ds := seg(name);
      dx := ofs(name)+1;
      intr($21,regs);
      if not odd(flags) then kanal1 := ax
      else writeln('Fehler beim ffnen : ',ax);
    end;

(* ffnen der Text-Datei (Schnittstelle) COM6 *)

  name := 'COM5' + chr(0);
  with regs do
    begin
      ax := $3D02;
      ds := seg(name);
      dx := ofs(name)+1;
      intr($21,regs);
      if not odd(flags) then kanal2 := ax
      else writeln('Fehler beim ffnen : ',ax);
    end;


(* ffnen der Text-Datei TESTSIO3.PAS und Lesen der Text-Datei in den
   PC-Sende-Puffer *)

  assign(fil,'TESTSIO3.PAS');
  reset(fil);
  i := 1;
  while not eof(fil) do
    begin
      read(fil,speicher1[i]);
      inc(i);
    end;
  close(fil);

(* Lschen des PC-Empfangs-Puffers *)

  for k := 1 to i-1 do
    speicher2[k] := ' ';

(* Schreiben des PC-Sende-Puffers in die Schnittstelle COM5 *)

  with regs do
    begin
      ax := $4403;
      bx := kanal1;
      cx := i-1;
      ds := seg(speicher1);
      dx := ofs(speicher1);
      intr($21,regs);
    end;

(* Schlieen der Schnittstelle COM5 *)

  with regs do
    begin
      ax := $3E00;
      bx := kanal1;
      intr($21,regs);
      if not odd(flags) then
      else writeln('Fehler beim Schlieen : ',ax);
    end;

  write(i-1,' Daten gesendet, weiter mit <CR>');
  readln;

  writeln;
  writeln;

(* Lesen der Daten von der Schnittstelle COM6 in den PC-Empfangs-Puffer *)

l := 0;
repeat
  with regs do
    begin
      ax := $4402;
      bx := kanal2;
      cx := i-1;
      ds := seg(speicher2);
      dx := ofs(speicher2);
      intr($21,regs);
      l := ax;
      write(l,' Daten empfangen, weiter mit <CR>');readln;
    end;

(* Ausgabe auf Bildschirm *)

    for k := 1 to l do
      begin
        write(speicher2[k]); (* Schreiben auf den Bildschirm *)
{
        if speicher1[k] <> speicher2[k] then
          writeln(chr(7),'Fehler beim ',k,'. Zeichen: ',speicher1[k],' ',speicher2[k]);
 }
      end;
until l = 0;
  writeln;
  write('Einlesen beendet');
  writeln;

(* Schlieen der Schnittstelle COM6 *)

  with regs do
    begin
      ax := $3E00;
      bx := kanal2;
      intr($21,regs);
      if not odd(flags) then
      else writeln('Fehler beim Schlieen : ',ax);
    end;
end.
